<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task75</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">
  
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="./voucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./menu.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./drink.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./region.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./order.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order</p>
                </a>
              </li>
            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Order</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Order</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <h2 style="text-align: center">Quản lý order</h2>
        <div class="jumbotron container">
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="">Chọn khách hàng</label>
            </div>
            <div class="col-sm-9">
              <select name="" id="select-user" class="form-control">
                <option value="0">Chọn khách hàng</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="order-code">Order Code</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-order-Code" name="discount" placeholder="Order Code" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="Pizza Size">Pizza Size</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-pizza-size" placeholder="Pizza Size" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="Pizza type">Pizza type</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-pizza-type" placeholder="Pizza type" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="voucher">Voucher</label>
            </div>
            <div class="col-sm-9">
              <input type="text" id="input-voucher" placeholder="Voucher" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="Price">Price</label>
            </div>
            <div class="col-sm-9">
              <input type="number" id="input-Price" placeholder="Price" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="Paid">Paid</label>
            </div>
            <div class="col-sm-9">
              <input type="number" id="input-Paid" placeholder="Paid" class="form-control" />
            </div>
          </div>
          <div class="row mb-3 pull-right">
            <div class="col-sm-12 d-flex justify-content-around">
              <button class="btn btn-primary" id="btn-create-user">
                New User
              </button>
              <button id="btn-update-user" class="btn btn-info">
                Update User
              </button>
              <button class="btn btn-danger" id="btn-delete-user">
                Delete User
              </button>
              <button class="btn btn-danger" id="btn-delete-all-User">
                Delete ALL User
              </button>
            </div>
          </div>
          <div class="row pull-right">
            <div class="col-sm-12 d-flex justify-content-around">
              <button class="btn btn-primary" id="create-order">
                Create Order
              </button>
              <button id="update-order" class="btn btn-info">Update Order</button>
              <button class="btn btn-danger" id="delete-all-order">
                Delete Order
              </button>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover text-center" id="order-table">
          <thead>
            <tr>
              <th>Order Code</th>
              <th>Pizza Size</th>
              <th>Pizza Type</th>
              <th>Voucher Code</th>
              <th>Price</th>
              <th>Paid</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
        <!-- Modal delete order-->
        <div class="modal fade" id="modal-delete-order">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xác nhận xóa order</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn xóa order</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-danger" id="btn-confirm-delete-order">
                  Delete
                </button>
              </div>
            </div>
          </div>
        </div>
        <!-- Modal create-->
        <div class="modal hide" id="modal-create-user">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-primary">Manage User</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="">Full Name</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-fullname" placeholder="Full Name" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="email">Email</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-email" placeholder="Email" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="phone">Phone</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-phone" placeholder="Phone" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="address">Address</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-address" placeholder="Address" class="form-control" />
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-primary" id="btn-save-user">
                  Save Data
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal update-->
        <div class="modal hide" id="modal-update-user">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-primary">Update User</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="">Full Name</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-fullname-update" placeholder="Full Name" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="email">Email</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-email-update" placeholder="Email" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="phone">Phone</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-phone-update" placeholder="Phone" class="form-control" />
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="address">Address</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-address-update" placeholder="Address" class="form-control" />
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-primary" id="btn-confirm-update">
                  Update Data
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal delete user-->
        <div class="modal fade" id="modal-delete-user">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xác nhận xóa User</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn xóa User</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-danger" id="btn-confirm-delete-user">
                  Delete
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- Modal delete all user-->
        <div class="modal fade" id="modal-delete-all-user">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xác nhận</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6 class="text-danger">Bạn có chác muốn tất cả User</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Close
                </button>
                <button type="button" class="btn btn-danger" id="btn-confirm-delete-all-user">
                  Delete
                </button>
              </div>
            </div>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gListCol = ["orderCode", "pizzaSize", "pizzaType", "voucherCode", "price", "paid"];
    const gCOL_ORDER_CODE = 0;
    const gCOL_PIZZA_SIZE = 1;
    const gCOL_PIZZA_TYPE = 2;
    const gCOL_VOUCHER_CODE = 3;
    const gCOL_PRICE = 4;
    const gCOL_PAID = 5;


    var gTableOrders = $("#order-table").DataTable({
      columns: [
        { data: gListCol[gCOL_ORDER_CODE] },
        { data: gListCol[gCOL_PIZZA_SIZE] },
        { data: gListCol[gCOL_PIZZA_TYPE] },
        { data: gListCol[gCOL_VOUCHER_CODE] },
        { data: gListCol[gCOL_PRICE] },
        { data: gListCol[gCOL_PAID] }
      ]

    });

    // Biến toàn cục để lưu số thứ tự
    var gStt = 1;

    // Biến hành động tạo mới
    const gACTION_CREATE = "create";
    // Biến hành động cập nhật
    const gACTION_UPDATE = "update";
    // Biến toàn cục để lưu số thứ tự
    var gStt = 1;
    // Biến lưu id của nhân viên
    var gOrderId = null;
    // Biến lưu id của phòng ban
    var gUserId = null;
    // Biến lưu toàn bộ phòng ban
    var gListUser = null;
    // Biến để lưu toàn bộ nhân viên
    var gListOrder = null;
    // Biến để lưu hành động thực hiện với department
    var gActionCustomer = null;
    // Biến để lưu hành động thực hiện với employee
    var gActionOrder = null;


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();

    // Thực thi sự kiện thay đổi phòng ban
    $("#select-user").on("change", function () {
      gUserId = $("#select-user").val();
      console.log(gUserId);
      callApiLoadToLoadListOrderToTable();
    });

    // Thực thi sự kiện nhấn vào row trong datatable
    $("#order-table").on("click", "tr", function () {
      onClickTableRow(this);
    });


    // Thực thi sự kiện nhấn nút thêm mới phòng ban
    $("#btn-create-user").on("click", function () {
      $("#modal-create-user").modal("show");
    });


    // Hàm thực thi sự kiện nhấn nút thêm mới trong modal thêm mới phòng ban
    $("#btn-save-user").on("click", function () {
      onBtnCreateNewCustomer();
    });

    // Thực thi sự kiện nhấn nút cập nhật phòng ban
    $("#btn-update-user").on("click", function () {
      onBtnUpdateUserClick();
    });

    // Thực thi sự kiện nhấn nút confirm update trong modal
    $("#btn-confirm-update").on("click", function () {
      onBtnConfirmUpdateClick();
    });

    // Thực thi sự kiện nhấn nút xóa phòng ban
    $("#btn-delete-user").on("click", function () {
      onBtnDeleteDepartmentClick();
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa phòng ban trong modal delete
    $("#btn-confirm-delete-user").on("click", function () {
      callApiToDeleteUser();
    });

    // Thực thi sự kiện nhấn nút xóa tất cả phòng ban
    $("#btn-delete-all-User").on("click", function () {
      $("#modal-delete-all-user").modal("show");
    });

    // Thực thi sự kiện nhấn nút confirm xóa tất cả phòng ban
    $("#btn-confirm-delete-all-user").on("click", function () {
      onBtnConfirmDeleteAllUserClick();
    });

    // Thực thi sự kiện nhấn nút thêm mới nhân viên
    $("#create-order").on("click", function () {
      // Kiểm tra xem đã chọn phòng ban chưa
      if (checkSelectUser()) {
        onBtnCreateNewOrderClick();
      }
    });

    // Thực thi sự kiện nhấn nút cập nhật thông tin nhân viên
    $("#update-order").on("click", function () {
      if (checkSelectUser) {
        if (gOrderId != null) {
          onBtnUpdateOrderClick();
        }
        else {
          alert("Vui lòng chọn đơn hàng muốn cập nhật thông tin!");
        }
      }
    });

    // Thực thi sự kiện nhấn nút xóa nhân viên
    $("#delete-all-order").on("click", function () {
      if (gOrderId != null) {
        $("#modal-delete-order").modal("show");
      }
      else {
        alert("Vui lòng chọn order muốn xóa!");
      }
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa trong modal delete nhân viên
    $("#btn-confirm-delete-order").on("click", function () {
      onBtnConfirmDeleteOrderClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callApiToLoadListUserToSelectUser();
      callApiToGetListOrder();
    }

    // Hàm xử lý sự kiện nhấn vào row trong table
    // Khi nhấn vào row thì lấy dữ liệu ra và điền vào form
    function onClickTableRow(paramRow) {
      var vDataRow = gTableOrders.row(paramRow).data();
      gOrderId = vDataRow.id;
      // Gọi hàm load dữ liệu row vào form
      loadOrderDataToForm(vDataRow);
    }

    // Hàm xử lý sự kiện nhấn nút thêm phòng ban trong modal thêm mới
    function onBtnCreateNewCustomer() {
      gActionCustomer = gACTION_CREATE;
      var vNewCustomer = {
        fullname: "",
        email: "",
        phone: "",
        address: ""
      }
      // Gọi hàm lấy giá trị insert phòng ban
      getNewUserData(vNewCustomer);
      console.log(vNewCustomer);
      // validate dữ liệu
      var vValidate = validateUserData(vNewCustomer);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToCreateNewUser(vNewCustomer);
      }
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban
    function onBtnUpdateUserClick() {
      if (checkSelectUser()) {
        $("#modal-update-user").modal("show");
        callApiToGetUserDataById();
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa phòng ban 
    function onBtnDeleteDepartmentClick() {
      if (checkSelectUser()) {
        $("#modal-delete-user").modal("show");
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa nhân viên

    // Hàm xử lý sự kiện nhấn nút xác nhận xóa tất cả phòng ban trong modal xóa tất cả
    function onBtnConfirmDeleteAllUserClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/users",
        success: function (paramRes) {
          alert("Tất cả user đã được xóa!");
          $("#modal-delete-all-user").modal("hide");
          callApiToLoadListUserToSelectUser();
        },
        error: function (paramError) {
          alert("Xóa tất cả user thất bại, vui lòng thử lại!");
          $("#modal-delete-all-user").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật phòng ban trong modal
    function onBtnConfirmUpdateClick() {
      gActionCustomer = gACTION_UPDATE;
      var vUser = {
        fullname: "",
        email: "",
        phone: "",
        address: ""
      }
      // Gọi hàm lấy giá trị phòng ban update
      getDataUpdate(vUser);
      console.log(vUser);
      // validate dữ liệu
      var vValidate = validateUserData(vUser);
      if (vValidate) {
        // Gọi APi để thêm mới phòng ban
        callApiToUpdateUser(vUser);
      }
    }

    // Hàm xử lý sự kiện nhấn nút tạo mới nhân viên
    function onBtnCreateNewOrderClick() {
      gActionOrder = gACTION_CREATE;
      var vNewOrder = {
        orderCode: "",
        pizzaSize: "",
        pizzaType: "",
        voucherCode: "",
        price: "",
        paid: ""
      }
      getOrderDataForm(vNewOrder);
      console.log(vNewOrder);
      var vValidate = validateOrderData(vNewOrder);
      if (vValidate) {
        callApiToCreateNewOrder(vNewOrder);
      }
    }

    // Hàm xử lý sự kiện nhấn nút update nhân viên
    function onBtnUpdateOrderClick() {
      gActionOrder = gACTION_UPDATE;
      var vOrder = {
        orderCode: "",
        pizzaSize: "",
        pizzaType: "",
        voucherCode: "",
        price: "",
        paid: ""
      }
      getOrderDataForm(vOrder);
      console.log(vOrder);
      var vValidate = validateOrderData(vOrder);
      if (vValidate) {
        callApiToUpdateOrder(vOrder);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa một nhân viên
    function onBtnConfirmDeleteOrderClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/order/" + gOrderId,
        success: function (paramRes) {
          alert("Xóa order thành công!");
          $("#modal-delete-order").modal("hide");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListOrderToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListOrder();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          console.log(paramError.status);
          alert("Xóa order thất bại, vui lòng thử lại!");
          $("#modal-delete-order").modal("hide");
        }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi API để lấy ra danh sách phòng ban đưa vào thẻ select
    function callApiToLoadListUserToSelectUser() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/users",
        success: function (paramRes) {
          console.log(paramRes);
          gListUser = paramRes;
          loadDataToSelectCustomer(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để lấy danh sách toàn bộ nhân viên
    function callApiToGetListOrder() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/orders",
        success: function (paramRes) {
          gListOrder = paramRes;
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào thẻ select Customer
    function loadDataToSelectCustomer(paramDataCustomer) {
      var vSelectCustomer = $("#select-user");
      vSelectCustomer.html("");
      $("<option>", {
        value: "none",
        text: "Chọn khách hàng"
      }).appendTo(vSelectCustomer);
      for (var bI = 0; bI < paramDataCustomer.length; bI++) {
        $("<option>", {
          value: paramDataCustomer[bI].id,
          text: paramDataCustomer[bI].fullname
        }).appendTo(vSelectCustomer);
      }
    }

    // Hàm call Api load ra danh sách nhân viên khi chọn phòng ban
    function callApiLoadToLoadListOrderToTable() {
      var vUserId = $("#select-user").val();
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/user/" + vUserId + "/orders",
        success: function (paramRes) {
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      });
    }

    // Hàm load dữ liệu vào bảng nhân viên
    function loadDataToTable(paramOrderData) {
      gStt = 1;
      gTableOrders.clear();
      gTableOrders.rows.add(paramOrderData);
      gTableOrders.draw();
    }

    // Hàm load thông tin nhân viên vào fomr
    function loadOrderDataToForm(paramOrderData) {
      $("#input-order-Code").val(paramOrderData.orderCode);
      $("#input-pizza-size").val(paramOrderData.pizzaSize);
      $("#input-pizza-type").val(paramOrderData.pizzaType);
      $("#input-voucher").val(paramOrderData.voucherCode);
      $("#input-Price").val(paramOrderData.price);
      $("#input-Paid").val(paramOrderData.paid);

    }

    // Hàm chỉnh lại form của ngày tháng cho phù hợp
    function formatDate(paramDate) {
      // tách ra từng phần thông qua hàm split, sau đó sắp xếp theo kiểu của input date là yy-MM-dd"
      var vListDate = paramDate.split("-");
      return vListDate[2] + "-" + vListDate[1] + "-" + vListDate[0];
    }

    // Hàm lấy thông tin phòng ban thêm mới
    function getNewUserData(paramDataUser) {
      paramDataUser.fullname = $("#input-fullname").val().trim();
      paramDataUser.email = $("#input-email").val().trim();
      paramDataUser.phone = $("#input-phone").val().trim();
      paramDataUser.address = $("#input-address").val().trim();
    }

    // Hàm validate dữ liệu phòng ban
    function validateUserData(paramDataUser) {
      if (paramDataUser.fullname == "") {
        alert("Vui lòng nhập tên đầy đủ!");
        return false;
      }

      if (paramDataUser.email == "") {
        alert("Vui lòng nhập email!");
        return false;
      }

      if (paramDataUser.phone == "") {
        alert("Vui lòng nhập số điện thoại!");
        return false;
      }

      if (paramDataUser.address == "") {
        alert("Vui lòng nhập địa chỉ!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để tạo mới 1 phòng ban
    function callApiToCreateNewUser(paramDataUser) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/users",
        contentType: "application/json",
        data: JSON.stringify(paramDataUser),
        success: function (paramRes) {
          alert("Thêm mới user thành công!");
          callApiToLoadListUserToSelectUser();
          $("#modal-create-user").modal("hide");
          resetFormCreateNewDepartment();
        },
        error: function (paramError) {
          alert("Tạo mới user thất bại, vui lòng thử lại");
          $("#modal-create-user").modal("hide");
          console.log(paramError.status);
        }
      })
    }

    // Hàm lấy giá trị phòng ban trong modal update
    function getDataUpdate(paramDataUser) {
      paramDataUser.fullname = $("#input-fullname-update").val().trim();
      paramDataUser.email = $("#input-email-update").val().trim();
      paramDataUser.address = $("#input-address-update").val().trim();
      paramDataUser.phone = $("#input-phone-update").val().trim();
    }

    // Hàm gọi API để lấy dữ liệu phòng ban thông qua ID
    function callApiToGetUserDataById() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/user/" + gUserId,
        success: function (paramRes) {
          console.log(paramRes);
          loadUserDataToFormUpdate(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      })
    }

    // Hàm load dữ liệu phòng ban vào form update
    function loadUserDataToFormUpdate(paramDataUser) {
      $("#input-fullname-update").val(paramDataUser.fullname);
      $("#input-email-update").val(paramDataUser.email);
      $("#input-phone-update").val(paramDataUser.phone);
      $("#input-address-update").val(paramDataUser.address);

    }

    // Hàm gọi API để cập nhật thông tin phòng ban
    function callApiToUpdateUser(paramDataUser) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/user/" + gUserId,
        contentType: "application/json",
        data: JSON.stringify(paramDataUser),
        success: function (paramRes) {
          alert("Cập nhật user thành công!");
          callApiToLoadListUserToSelectUser();
          $("#modal-update-user").modal("hide");
        },
        error: function (paramError) {
          alert("Cập nhật user thất bại, vui lòng thử lại");
          $("#modal-update-user").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để xóa 1 phòng ban thông qua ID
    function callApiToDeleteUser() {
      console.log(gUserId);
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/user/" + gUserId,
        success: function (paramRes) {
          alert("Xóa user thành công!");
          callApiToLoadListUserToSelectUser();
          $("#modal-delete-user").modal("hide");
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Xóa user thất bại, vui lòng thử lại");
          $("#modal-delete-user").modal("hide");
          console.log(paramError.status);
        }
      });
    }

    // Hàm reset form tạo mới phòng ban
    function resetFormCreateNewDepartment() {
      $("#input-fullname").val("");
      $("#input-email").val("");
      $("#input-phone").val("");
      $("#input-address").val("");
    }

    // Hàm lấy thông tin nhân viên thêm mới
    function getOrderDataForm(paramOrderData) {
      paramOrderData.orderCode = $("#input-order-Code").val().trim();
      paramOrderData.pizzaSize = $("#input-pizza-size").val().trim();
      paramOrderData.pizzaType = $("#input-pizza-type").val().trim();
      paramOrderData.voucherCode = $("#input-voucher").val().trim();
      paramOrderData.price = $("#input-Price").val().trim();
      paramOrderData.paid = $("#input-Paid").val().trim();
    }

    // Hàm kiểm tra đã chọn phòng ban hay chưa
    function checkSelectUser() {
      var vUserId = $("#select-user").val();
      if (vUserId == "none") {
        alert("Vui lòng chọn khách hàng");
        return false;
      }
      else {
        gUserId = vUserId;
        return true;
      }
    }

    // Hàm validate dữ liệu employee
    function validateOrderData(paramOrderData) {
      if (paramOrderData.orderCode == "") {
        alert("Vui lòng nhập ordercode!");
        return false;
      }
      // Gọi hàm kiểm tra xem mã nhân viên có bị trùng hay không
      if (checkDuplicateOrderCode(paramOrderData.orderCode)) {
        alert("Ordercode đã tồn tại!");
        return false;
      }

      if (paramOrderData.pizzaSize == "") {
        alert("Vui lòng chọn size pizza!");
        return false;
      }
      if (paramOrderData.pizzaType == "") {
        alert("Vui lòng nhập loại pizza!");
        return false;
      }
      if (paramOrderData.price == "") {
        alert("Vui lòng nhập giá tiền!");
        return false;
      }

      if (paramOrderData.paid == "") {
        alert("Vui lòng nhập số tiền phải thanh toán!");
        return false;
      }
      return true;
    }

    // Hàm gọi API để thêm mới 1 nhân viên
    function callApiToCreateNewOrder(paramOrder) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/user/" + gUserId + "/orders",
        contentType: "application/json",
        data: JSON.stringify(paramOrder),
        success: function (paramRes) {
          alert("Order thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListOrderToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListOrder();
          // Reset lại form
          resetFormEmployee();
        },
        error: function (paramError) {
          alert("Order thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm gọi API để cập nhật thông tin 1 nhân viên
    function callApiToUpdateOrder(paramOrderData) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/user/" + gUserId + "/order/" + gOrderId,
        contentType: "application/json",
        data: JSON.stringify(paramOrderData),
        success: function (paramRes) {
          alert("Cập nhật bài viết thành công!");
          // load lại danh sách nhân viên phòng ban đó đưa vào table
          callApiLoadToLoadListOrderToTable();
          // Lấy danh sách toàn bộ nhân viên
          callApiToGetListOrder();
          // Reset lại form
          resetFormEmployee();

        },
        error: function(paramError) {
          alert("Cập nhật bài viết thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm kiểm tra có trùng Department code hay không
    function checkDuplicateMaChuong(paramDepartmentCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListUser.length) {
        if (gListUser[vIndex].maChuong == paramDepartmentCode && gActionCustomer == gACTION_CREATE) {
          return true;
        }
        else if(gListUser[vIndex].maChuong == paramDepartmentCode && gActionCustomer == gACTION_UPDATE && gListUser[vIndex].id != gUserId) {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }

    // Hàm kiểm tra mã nhân viên đã tồn tại hay chưa
    function checkDuplicateOrderCode(paramOrderCode) {
      var vIndex = 0;
      var vDuplicated = false;
      while (vIndex < gListOrder.length) {
        // Nếu hành động thực hiện là tạo thì trả về true và có 1 code khác trùng thì trả về true
        if (gListOrder[vIndex].orderCode == paramOrderCode && gActionOrder == gACTION_CREATE) {
          return true;
        }
        // Nếu hành động thực hiện là update mà có 1 code khác trùng nhưng khác vs ID cập nhật thì trả về true 
        else if(gListOrder[vIndex].orderCode == paramOrderCode && gActionOrder == gACTION_UPDATE && gListOrder[vIndex].id != gOrderId)
        {
          return true;
        }
        else {
          vIndex++;
        }
      }
      return vDuplicated;
    }


    // Hàm reset form employee
    function resetFormEmployee() {
      $("#input-order-Code").val("");
      $("#input-pizza-size").val("");
      $("#input-pizza-type").val("");
      $("#input-voucher").val("");
      $("#input-Price").val("");
      $("#input-Paid").val("");
    }

  </script>
</body>

</html>